Attribute VB_Name = "modChanServ"
'ignitionServices is (C)  Keith Gable, Nigel Jones and Reid Burke.
'----------------------------------------------------
'You must include this notice in any modifications you make. You must additionally
'follow the GPL's provisions for sourcecode distribution and binary distribution.
'If you are not familiar with the GPL, please read LICENSE.TXT.
'(you are welcome to add a "Based On" line above this notice, but this notice must
'remain intact!)
'Released under the GNU General Public License
'Contact information: Keith Gable (Ziggy) <ziggy@ignition-project.com>
'                     Nigel Jones (DigiGuy) <digiguy@ignition-project.com>
'                     Reid Burke  (AirWalk) <airwalk@ignition-project.com>
'
'
' $Id: Copy\040of\040modChanServ.bas,v 1.1.1.1 2004/05/29 02:04:43 ziggythehamster Exp $
'
'
'This program is free software.
'You can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the License,
'or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
'Without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
'See the GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License along with this program.
'if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
Option Explicit
Option Base 0

Public Function ChanToFN(strConvert As String) As String
'\ / : * ? " < > | #
'B F C A Q D L G U P

'This sub replaces illegal filename chars with those that
'are legal. There are a few known pitfalls. For example,
'if the channel name is #D#, the channel won't work right as a
'registered channel (it will probably create it fine, but won't
'check it). # needs to be blocked at the server, and then we'll
'be fine.
Dim x As String
x = strConvert
If Left(x, 1) = "#" Then x = Right(x, Len(x) - 1)
x = Replace(x, "\b", " ")
x = Replace(x, "\c", ",")
x = Replace(x, "#", "#P#")
x = Replace(x, "\\", "#S#")
x = Replace(x, "\r", "#R#")
x = Replace(x, "\n", "#N#")
x = Replace(x, "\t", "#T#")
x = Replace(x, "\", "#B#")
x = Replace(x, "/", "#F#")
x = Replace(x, ":", "#C#")
x = Replace(x, "*", "#A#")
x = Replace(x, "?", "#Q#")
x = Replace(x, """", "#D#")
x = Replace(x, "<", "#L#")
x = Replace(x, ">", "#G#")
x = Replace(x, "|", "#U#")
ChanToFN = x
End Function
Public Function FNToChan(strConvert As String) As String
Dim x As String
x = strConvert
x = Replace(x, " ", "\b")
x = Replace(x, ",", "\b")
x = Replace(x, "#P#", "#")
x = Replace(x, "#S#", "\\")
x = Replace(x, "#R#", "\r")
x = Replace(x, "#N#", "\n")
x = Replace(x, "#T#", "\t")
x = Replace(x, "#B#", "\")
x = Replace(x, "#F#", "/")
x = Replace(x, "#C#", ":")
x = Replace(x, "#A#", "*")
x = Replace(x, "#Q#", "?")
x = Replace(x, "#D#", """")
x = Replace(x, "#L#", "<")
x = Replace(x, "#G#", ">")
x = Replace(x, "#U#", "|")
FNToChan = "#" & x
End Function
Public Function GetChanProp(tmpChan As String, Prop As String) As String
'On Error Resume Next
Dim F As Integer, tmpVar As String, tmpLine() As String, Chan As String
Chan = ChanToFN(tmpChan)
F = FreeFile
InternalDebug "coming into getchanprop, chan='" & Chan & "'"

If Dir(App.Path & "\ChanServ\" & Chan & ".isc") <> vbNullString Then
  Open App.Path & "\ChanServ\" & Chan & ".isc" For Input As F
    Do
      Line Input #F, tmpVar
      If Left(tmpVar, 1) = " " Then GoTo NextLine
      If Left(tmpVar, 1) = "#" Then GoTo NextLine
      If Left(tmpVar, 1) = ";" Then GoTo NextLine
      If Left(tmpVar, 1) = "[" Then GoTo NextLine
      If tmpVar = vbNullString Then GoTo NextLine
      
      tmpLine = Split(tmpVar, "=")
      If UCase(tmpLine(0)) = UCase(Prop) Then
        GetChanProp = Replace(AllBounds(tmpLine), "$NULL$", "")
        InternalDebug "Chan='" & Chan & "' Prop='" & Prop & "' Value='" & Replace(AllBounds(tmpLine), "$NULL$", "") & "'"
        Close F
        Exit Function
      End If
NextLine:
    Loop Until EOF(F)
  Close F
  GetChanProp = ""
Else
  GetChanProp = ""
End If
End Function
Public Function ChanExist(strChannel As String) As Boolean
Dim A As Long
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    ChanExist = True
    Exit Function
  End If
Next A
ChanExist = False
End Function
Public Sub AddUserToChan(strChannel As String, strUser As String)
Dim A As Long
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    Channels(A).Users = Channels(A).Users & " " & strUser
    If Left(Channels(A).Users, 1) = " " Then Channels(A).Users = Right(Channels(A).Users, Len(Channels(A).Users) - 1)
    InternalDebug "added '" & strUser & "' to '" & strChannel & "'"
    InternalDebug "total users-'" & Channels(A).Users & "'"
  End If
Next A
End Sub
Public Function IsOwner(strChannel As String, strUser As String) As Boolean
Dim A As Long
Dim b As Long
Dim tmpU() As String
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    InternalDebug "IsOwner - Owners for '" & strChannel & "' are '" & Channels(A).Owners & "'"
    tmpU() = Split(Channels(A).Owners, " ")
    For b = 0 To UBound(tmpU)
      If UCase(tmpU(b)) = UCase(strUser) Then
        IsOwner = True
        Exit Function
      End If
    Next b
  End If
Next A
IsOwner = False
End Function
Public Function IsUser(strChannel As String, strUser As String) As Boolean
Dim A As Long
Dim b As Long
Dim tmpU() As String
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    InternalDebug "IsUser - Users for '" & strChannel & "' are '" & Channels(A).Users & "'"
    tmpU() = Split(Channels(A).Users, " ")
    For b = 0 To UBound(tmpU)
      If UCase(tmpU(b)) = UCase(strUser) Then
        IsUser = True
        Exit Function
      End If
    Next b
  End If
Next A
IsUser = False
End Function
Public Function IsHost(strChannel As String, strUser As String) As Boolean
Dim A As Long
Dim b As Long
Dim tmpU() As String
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    InternalDebug "IsHost - Hosts for '" & strChannel & "' are '" & Channels(A).Hosts & "'"
    tmpU() = Split(Channels(A).Hosts, " ")
    For b = 0 To UBound(tmpU)
      If UCase(tmpU(b)) = UCase(strUser) Then
        IsHost = True
        Exit Function
      End If
    Next b
  End If
Next A
IsHost = False
End Function
Public Sub AddOwnerToChan(strChannel As String, strUser As String)
Dim A As Long
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    Channels(A).Owners = Channels(A).Owners & " " & strUser
    If Left(Channels(A).Owners, 1) = " " Then Channels(A).Owners = Right(Channels(A).Owners, Len(Channels(A).Owners) - 1)
    InternalDebug "added '" & strUser & "' as an owner to '" & strChannel & "'"
    InternalDebug "total owners-'" & Channels(A).Owners & "'"
  End If
Next A
End Sub
Public Sub RemoveOwnerFromChan(strChannel As String, strUser As String)
Dim A As Long
Dim b As Long
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    Channels(A).Owners = Replace(Channels(A).Owners, strUser, "")
    Channels(A).Owners = Replace(Channels(A).Owners, "  ", " ") 'remove double spaces that can occur
    If Right(Channels(A).Owners, 1) = " " Then Channels(A).Owners = Left(Channels(A).Owners, Len(Channels(A).Owners) - 1)
    InternalDebug "removed owner '" & strUser & "' from '" & strChannel & "'"
  End If
Next A
End Sub
Public Sub AddHostToChan(strChannel As String, strUser As String)
Dim A As Long
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    Channels(A).Hosts = Channels(A).Hosts & " " & strUser
    If Left(Channels(A).Hosts, 1) = " " Then Channels(A).Hosts = Right(Channels(A).Hosts, Len(Channels(A).Hosts) - 1)
    InternalDebug "added '" & strUser & "' as a host to '" & strChannel & "'"
    InternalDebug "total hosts-'" & Channels(A).Hosts & "'"
  End If
Next A
End Sub
Public Sub RemoveHostFromChan(strChannel As String, strUser As String)
Dim A As Long
Dim b As Long
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    Channels(A).Hosts = Replace(Channels(A).Hosts, strUser, "")
    Channels(A).Hosts = Replace(Channels(A).Hosts, "  ", " ") 'remove double spaces that can occur
    If Right(Channels(A).Hosts, 1) = " " Then Channels(A).Hosts = Left(Channels(A).Hosts, Len(Channels(A).Hosts) - 1)
    InternalDebug "removed host '" & strUser & "' from '" & strChannel & "'"
  End If
Next A
End Sub
Public Sub RemoveHostAllChans(strUser As String)
Dim A As Long
Dim b As Long
For A = 0 To UBound(Channels)
  Channels(A).Hosts = Replace(Channels(A).Hosts, strUser, "")
  Channels(A).Hosts = Replace(Channels(A).Hosts, "  ", " ") 'remove double spaces that can occur
  If Right(Channels(A).Hosts, 1) = " " Then Channels(A).Hosts = Left(Channels(A).Hosts, Len(Channels(A).Hosts) - 1)
  InternalDebug "removed host '" & strUser & "' from '" & Channels(A).Name & "'"
Next A
End Sub
Public Sub RemoveOwnerAllChans(strUser As String)
Dim A As Long
Dim b As Long
For A = 0 To UBound(Channels)
  Channels(A).Owners = Replace(Channels(A).Owners, strUser, "")
  Channels(A).Owners = Replace(Channels(A).Owners, "  ", " ") 'remove double spaces that can occur
  If Right(Channels(A).Owners, 1) = " " Then Channels(A).Owners = Left(Channels(A).Owners, Len(Channels(A).Owners) - 1)
  InternalDebug "removed owner '" & strUser & "' from '" & Channels(A).Name & "'"
Next A
End Sub
Public Sub RemoveUserAllChans(strUser As String)
Dim A As Long
Dim b As Long
For A = 0 To UBound(Channels)
  Channels(A).Users = Replace(Channels(A).Users, strUser, "")
  Channels(A).Users = Replace(Channels(A).Users, "  ", " ") 'remove double spaces that can occur
  If Right(Channels(A).Users, 1) = " " Then Channels(A).Users = Left(Channels(A).Users, Len(Channels(A).Users) - 1)
  InternalDebug "removed user '" & strUser & "' from '" & Channels(A).Name & "'"
Next A
End Sub
Public Sub RemoveChannel(strChannel As String)
Dim A As Long
Dim b As Long
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    'clear all users
    Channels(A).Users = ""
    Channels(A).Name = ""
    InternalDebug "removed '" & strChannel & "'"
  End If
Next A
End Sub
Public Sub AddChannel(strChannel As String)
ReDim Preserve Channels(UBound(Channels) + 1)
Channels(UBound(Channels)).Name = strChannel
InternalDebug "added '" & strChannel & "'"
End Sub
Public Sub RemoveUserFromChan(strChannel As String, strUser As String)
Dim A As Long
Dim b As Long
For A = 0 To UBound(Channels)
  If UCase(Channels(A).Name) = UCase(strChannel) Then
    Channels(A).Users = Replace(Channels(A).Users, strUser, "")
    Channels(A).Users = Replace(Channels(A).Users, "  ", " ") 'remove double spaces that can occur
    If Right(Channels(A).Users, 1) = " " Then Channels(A).Users = Left(Channels(A).Users, Len(Channels(A).Users) - 1)
    InternalDebug "removed '" & strUser & "' from '" & strChannel & "'"
    If Channels(A).Users = "" Then RemoveChannel strChannel
  End If
Next A
End Sub
Public Function ChanRegistered(strC As String) As Boolean
On Error GoTo CRFail
Dim strChan As String
strChan = ChanToFN(strC)
InternalDebug "checking if channel is registered - chan='" & strC & "' fn='" & strChan & "'"
If Dir(App.Path & "\ChanServ\" & strChan & ".isc") <> vbNullString Then
  ChanRegistered = True
End If
Exit Function
CRFail:
frmMain.wsMain.SendData ":ChanServ GNOTICE :There has been an error accessing '" & App.Path & "\ChanServ\" & strC & ".isc' on the local filesystem. An admin should check to see that ignitionServices can read/write to the file and that the filesystem is intact." & vbCrLf
ChanRegistered = False
End Function
Public Sub ProcChanServ(Nick As String, CommandLine As String)
InternalDebug "ChanServ"
If CommandLine = "" Then CommandLine = "HELP"
Dim Prefix As String
Prefix = ":ChanServ"

InternalDebug "Command: """ & UCase(Split(CommandLine, " ")(0)) & """"
Dim tmpSplit() As String
Dim tmpParams As Long
tmpSplit = Split(CommandLine, " ")
tmpParams = UBound(tmpSplit)
Dim F As Integer
Dim A As Integer
F = FreeFile
Select Case UCase(Split(CommandLine, " ")(0))
  Case "HELP"
    If UCase(CommandLine) = "HELP" Then
      'no additional help parameters
      With frmMain.wsMain
        .SendData Prefix & " NOTICE " & Nick & " :ChanServ allows you to ""register"" a channel and" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :change various settings of the channel. Under most" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :server configurations, the channel will be ""persistant"";" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :it will always remain open. Due to the versatility of IRCX," & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :most of ChanServ's functions can be done with normal commands." & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :To use a command, type /ChanServ command. For more" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :information on a specific command, type /ChanServ HELP command." & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " : REGISTER     Register a channel" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " : DROP         Unregisters a channel" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " : SET          Change various channel settings" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " : OWNER        Make a user an owner" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " : HOST         Make a user a host" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " : VOICE        Give a user a voice" & vbCrLf
      End With
    ElseIf UCase(CommandLine) = "HELP REGISTER" Then
      With frmMain.wsMain
        .SendData Prefix & " NOTICE " & Nick & " :.: Channel Registration :." & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :Registering a channel prevents it from being taken by" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :those without access. Channel registration usually" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :also makes your channel ""persistant"", which means that" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :it will not close when everybody leaves. You can register" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :a channel by typing:" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :/ChanServ REGISTER channel name owner key" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :Your nickname must be registered in order to register" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :a channel." & vbCrLf
      End With
    ElseIf UCase(CommandLine) = "HELP DROP" Then
      With frmMain.wsMain
        .SendData Prefix & " NOTICE " & Nick & " :.: Dropping Channels :." & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :Dropping a channel allows it to be re-registered by anyone." & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :If you are giving up ownership of the channel, you should" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :try SET FOUNDER. In order to drop a channel, you must be the" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :founder. This command is used by typing /ChanServ DROP channel name" & vbCrLf
      End With
    ElseIf UCase(CommandLine) = "HELP SET" Then
        With frmMain.wsMain
          .SendData Prefix & " NOTICE " & Nick & " :.: Channel Settings :." & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " :ChanServ lets you change various settings about your channel," & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " :such as your channel's URL or password. Here is a list of the" & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " :various settings you can change:" & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " : FOUNDER nickname          Sets the channel's founder; can only be set by the founder" & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " : URL web address           Changes the URL linked with your channel" & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " : PASSWORD new password     Changes the password for the current channel" & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " :This command should be used like this: /ChanServ SET channel name option parameters" & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " :Examples:" & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " : /ChanServ SET #Room FOUNDER SomeNickname         Sets the founder of #Room to SomeNickname" & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " : /ChanServ SET #localhost URL http://localhost/   Sets #localhost's URL to http://localhost/" & vbCrLf
          .SendData Prefix & " NOTICE " & Nick & " : /ChanServ SET #myroom PASSWORD abc123            Sets #myroom's password to abc123" & vbCrLf
        End With
    ElseIf UCase(CommandLine) = "HELP OWNER" Then
      With frmMain.wsMain
        .SendData Prefix & " NOTICE " & Nick & " :.: Ownering Users :." & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :The higheset level in a channel is an owner. You can use" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :this command, /ChanServ OWNER channel name nickname, or" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :/MODE channel name +q nickname to make someone an owner. In" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :order to make someone an owner, you must be an owner yourself." & vbCrLf
      End With
    ElseIf UCase(CommandLine) = "HELP HOST" Then
      With frmMain.wsMain
        .SendData Prefix & " NOTICE " & Nick & " :.: Hosting Users :." & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :The second-higheset level in a channel is a host. You can use" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :this command, /ChanServ HOST channel name nickname, or" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :/MODE channel name +o nickname to make someone a host. You" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :must be a host or an owner to use this command." & vbCrLf
      End With
    ElseIf UCase(CommandLine) = "HELP VOICE" Then
      With frmMain.wsMain
        .SendData Prefix & " NOTICE " & Nick & " :.: Voicing Users :." & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :Voices permit users to talk in a moderated channel. You can use" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :this command, /ChanServ VOICE channel name nickname, or" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :/MODE channel name +v nickname to give people a voice. You" & vbCrLf
        .SendData Prefix & " NOTICE " & Nick & " :must be a host or an owner to use this command." & vbCrLf
      End With
    Else
      frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :I don't recognize that particular command. Type /ChanServ HELP for a list of avaliable commands." & vbCrLf
    End If
  Case "REGISTER"
    If tmpParams <> 2 Then
      frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Invalid parameters. The correct usage of this command is: /ChanServ REGISTER channel name owner key" & vbCrLf
    Else
      If Not NickRegistered(Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Your nickname must be registered in order to register a channel." & vbCrLf
        Exit Sub
      End If
      If Not GetOnline(Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be identified to NickServ before you can register a channel." & vbCrLf
        Exit Sub
      End If
      If ChanRegistered(tmpSplit(1)) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :That channel, " & tmpSplit(1) & ", is already registered." & vbCrLf
        Exit Sub
      End If
      If Not IsOwner(tmpSplit(1), Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be an owner in " & tmpSplit(1) & " to register it." & vbCrLf
        Exit Sub
      End If
      
      Open App.Path & "\ChanServ\" & ChanToFN(tmpSplit(1)) & ".isc" For Output As F
      Print #F, "Founder=" & Nick
      Print #F, "OwnerKey=" & tmpSplit(2)
      Close F
      frmMain.wsMain.SendData Prefix & " MODE " & tmpSplit(1) & " +r" & vbCrLf
      frmMain.wsMain.SendData Prefix & " PROP " & tmpSplit(1) & " OWNERKEY :" & tmpSplit(2) & vbCrLf
      frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :" & tmpSplit(1) & " has been registered with the password of " & tmpSplit(2) & "." & vbCrLf
    End If
  Case "SET"
    If NickRegistered(Nick) Then
      If GetOnline(Nick) Then
        If tmpParams = 0 Then
          frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & ":Please type /ChanServ HELP SET for the usage of this command." & vbCrLf
          Exit Sub
        End If
        If ChanRegistered(tmpSplit(1)) Then
          If UCase(tmpSplit(2)) = "FOUNDER" Then
            If UCase(Nick) = UCase(GetChanProp(tmpSplit(1), "Founder")) Then
              If NickRegistered(tmpSplit(3)) Then
                ChangeChanProp tmpSplit(1), "Founder", tmpSplit(3)
                frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :The founder of " & tmpSplit(1) & " has successfully been changed to " & tmpSplit(3) & "." & vbCrLf
              Else
                frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You can not set the founder of a channel to a nickname that isn't registered." & vbCrLf
              End If
            Else
              frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be the channel's founder to complete that operation." & vbCrLf
            End If
          ElseIf UCase(tmpSplit(2)) = "URL" Then
            If IsOwner(tmpSplit(1), Nick) Or IsHost(tmpSplit(1), Nick) Then
              'must be a host or owner to complete this operation
              ChangeChanProp tmpSplit(1), "URL", tmpSplit(3)
              frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :The URL for " & tmpSplit(1) & " has been set to " & tmpSplit(3) & "." & vbCrLf
            Else
              frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be a host or owner in " & tmpSplit(1) & " to complete this operation." & vbCrLf
            End If
          ElseIf UCase(tmpSplit(2)) = "PASSWORD" Then
            If UCase(Nick) = UCase(GetChanProp(tmpSplit(1), "Founder")) Then
              ChangeChanProp tmpSplit(1), "Founder", tmpSplit(3)
              frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :The password for " & tmpSplit(1) & " has been set to " & tmpSplit(3) & "." & vbCrLf
            Else
              frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be the founder of " & tmpSplit(1) & " to complete this operation." & vbCrLf
            End If
          Else
            frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Invalid parameters. Type /ChanServ HELP SET for a list of parameters." & vbCrLf
          End If
        Else
          frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :That channel isn't registered." & vbCrLf
        End If
      Else
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be identified to NickServ to change the settings of a channel." & vbCrLf
      End If
    Else
      frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must have a registered nickname to change the settings of a channel." & vbCrLf
    End If
  Case "OWNER"
    If tmpParams <> 2 Then
      frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Invalid parameters. The correct usage of this command is: /ChanServ OWNER channel name nickname" & vbCrLf
    Else
      If Not NickRegistered(Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Your nickname must be registered to owner a user." & vbCrLf
        Exit Sub
      End If
      If Not GetOnline(Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be identified to NickServ before you can owner a user." & vbCrLf
        Exit Sub
      End If
      If Not ChanRegistered(tmpSplit(1)) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :The channel must be registered in order for you to use the OWNER command." & vbCrLf
        Exit Sub
      End If
      If Not IsOwner(tmpSplit(1), Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You are not an owner in that channel." & vbCrLf
        Exit Sub
      End If
      'they can owner the user
      frmMain.wsMain.SendData Prefix & " MODE " & tmpSplit(1) & " +q " & tmpSplit(2) & vbCrLf
    End If
  Case "HOST"
    If tmpParams <> 2 Then
      frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Invalid parameters. The correct usage of this command is: /ChanServ HOST channel name nickname" & vbCrLf
    Else
      If Not NickRegistered(Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Your nickname must be registered to host a user." & vbCrLf
        Exit Sub
      End If
      If Not GetOnline(Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be identified to NickServ before you can host a user." & vbCrLf
        Exit Sub
      End If
      If Not ChanRegistered(tmpSplit(1)) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :The channel must be registered in order for you to use the HOST command." & vbCrLf
        Exit Sub
      End If
      If Not IsOwner(tmpSplit(1), Nick) Or IsHost(tmpSplit(1), Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You are not an owner or host in that channel." & vbCrLf
        Exit Sub
      End If
      frmMain.wsMain.SendData Prefix & " MODE " & tmpSplit(1) & " +o " & tmpSplit(2) & vbCrLf
    End If
  Case "VOICE"
    If tmpParams <> 2 Then
      frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Invalid parameters. The correct usage of this command is: /ChanServ VOICE channel name nickname" & vbCrLf
    Else
      If Not NickRegistered(Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Your nickname must be registered to give a user a voice." & vbCrLf
        Exit Sub
      End If
      If Not GetOnline(Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be identified to NickServ before you can give a user a voice." & vbCrLf
        Exit Sub
      End If
      If Not ChanRegistered(tmpSplit(1)) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :The channel must be registered in order for you to use the VOICE command." & vbCrLf
        Exit Sub
      End If
      If Not IsOwner(tmpSplit(1), Nick) Or IsHost(tmpSplit(1), Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You are not an owner or host in that channel." & vbCrLf
        Exit Sub
      End If
      frmMain.wsMain.SendData Prefix & " MODE " & tmpSplit(1) & " +v " & tmpSplit(2) & vbCrLf
    End If
  Case "DROP"
    If tmpParams <> 1 Then
      frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Invalid parameters. The correct usage of this command is: /ChanServ DROP channel name" & vbCrLf
    Else
      If Not NickRegistered(Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :Your nickname must be registered to drop a channel." & vbCrLf
        Exit Sub
      End If
      If Not GetOnline(Nick) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be identified to NickServ before you can drop a channel." & vbCrLf
        Exit Sub
      End If
      If Not ChanRegistered(tmpSplit(1)) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :That channel, " & tmpSplit(1) & ", is not registered." & vbCrLf
        Exit Sub
      End If
      If UCase(Nick) <> UCase(GetChanProp(tmpSplit(1), "Founder")) Then
        frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :You must be the founder of " & tmpSplit(1) & " to drop it." & vbCrLf
        Exit Sub
      End If
      Kill App.Path & "\ChanServ\" & ChanToFN(tmpSplit(1)) & ".isc"
      frmMain.wsMain.SendData Prefix & " MODE " & tmpSplit(1) & " -r" & vbCrLf
      frmMain.wsMain.SendData Prefix & " NOTICE " & Nick & " :" & tmpSplit(1) & " has been dropped." & vbCrLf
    End If
End Select
End Sub
Public Sub ChangeChanProp(tmpChan As String, Prop As String, NewValue As String)
On Error Resume Next
Dim F As Integer, tmpVar As String, tmpLine() As String, NewFile As String, Added As Boolean, Chan As String
F = FreeFile
NewFile = ""
Chan = tmpChan
Open App.Path & "\ChanServ\" & Chan & ".isc" For Input As F
  Do
    Line Input #F, tmpVar
    If Left(tmpVar, 1) = " " Then GoTo NextLine
    If Left(tmpVar, 1) = "#" Then GoTo NextLine
    If Left(tmpVar, 1) = ";" Then GoTo NextLine
    If Left(tmpVar, 1) = "[" Then GoTo NextLine
    If tmpVar = vbNullString Then GoTo NextLine
    
    tmpLine = Split(tmpVar, "=")
    If UCase(tmpLine(0)) = UCase(Prop) Then
      If NewValue = "" Then NewValue = "$NULL$"
      Added = True
      NewFile = NewFile & Prop & "=" & NewValue & vbCrLf
    Else
      NewFile = NewFile & tmpVar & vbCrLf
    End If
NextLine:
  Loop Until EOF(F)
Close F
F = FreeFile
'if the property didn't already exist, add it to the end
If Added = False Then NewFile = NewFile & Prop & "=" & NewValue & vbCrLf: Added = True
Open App.Path & "\ChanServ\" & Chan & ".isc" For Output As F
  Print #F, NewFile
Close F
End Sub

