Attribute VB_Name = "modTime"
'ignitionServices is (C)  Keith Gable, Nigel Jones and Reid Burke.
'----------------------------------------------------
'You must include this notice in any modifications you make. You must additionally
'follow the GPL's provisions for sourcecode distribution and binary distribution.
'If you are not familiar with the GPL, please read LICENSE.TXT.
'(you are welcome to add a "Based On" line above this notice, but this notice must
'remain intact!)
'Released under the GNU General Public License
'Contact information: Keith Gable (Ziggy) <ziggy@ignition-project.com>
'                     Nigel Jones (DigiGuy) <digiguy@ignition-project.com>
'                     Reid Burke  (AirWalk) <airwalk@ignition-project.com>
'
'
' $Id: modTime.bas,v 1.1.1.1 2004/05/29 02:05:04 ziggythehamster Exp $
'
'
'This program is free software.
'You can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the License,
'or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
'Without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
'See the GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License along with this program.
'if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Public Type SYSTEMTIME
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
End Type
Public Type TIME_ZONE_INFORMATION
        Bias As Long
        StandardName(32) As Integer
        StandardDate As SYSTEMTIME
        StandardBias As Long
        DaylightName(32) As Integer
        DaylightDate As SYSTEMTIME
        DaylightBias As Long
End Type

Public Declare Function GetTimeZoneInformation Lib "kernel32" (lpTimeZoneInformation As TIME_ZONE_INFORMATION) As Long

Public Function GetGMTBias() As Integer
    Dim lpTimeZoneInformation As TIME_ZONE_INFORMATION
    
    GetTimeZoneInformation lpTimeZoneInformation
    GetGMTBias = lpTimeZoneInformation.Bias
End Function


Public Function GetGMTBiasString() As String
    Dim x As Long, y As Long
    x = -GetGMTBias
    y = x Mod 60
   
    x = x \ 60
    If y < 0 Then
        y = -y
        GetGMTBiasString = "GMT-" & Format$(x, "00") & ":" & _
        Format$(y, "00")
    ElseIf x < 0 Then
        GetGMTBiasString = "GMT-" & _
        Format$(x, "00") & ":" & Format$(y, "00")
    Else
        GetGMTBiasString = "GMT+" & _
        Format$(x, "00") & ":" & Format$(y, "00")
    End If
End Function


Function CTime() As Long
    CTime = toCTime(Now)
End Function

Function toCTime(d As Date) As Long
    toCTime = DateDiff("s", CDate(#1/1/1970# - GetGMTBias / 60 / 24), d)
End Function

Function AscTime(CTime As Long) As Date
    AscTime = CDate(#1/1/1970# - GetGMTBias / 60 / _
    24) + (CTime / 3600& / 24)
End Function
Public Function irc_time(TheTime As String) As String
    Dim lpTime As TIME_ZONE_INFORMATION
    Dim TheDate As Date
    Dim Msg
    
    On Error GoTo err_handle
    
    TheDate = "January 1 1970 00:00:00"
    GetTimeZoneInformation lpTime
    
    If IsNumeric(TheTime) Then
        'given timer
        irc_time = Format(DateAdd("s", Val(TheTime) - (lpTime.Bias * 60), TheDate), "dddd, MMMM d yyyy hh:mm:ss")
    Else
        'given date
        irc_time = (DateDiff("s", TheDate, TheTime) - (lpTime.Bias * 60))
    End If
    Exit Function
err_handle:
    InternalDebug "~~~ Time Conversion Failed. Input: " & TheTime
    irc_time = "Invalid date/time format"
End Function





