;ignitionServices is (C) Keith Gable and Contributors
;----------------------------------------------------
;You must include this notice in any modifications you make. You must additionally
;follow the GPL's provisions for sourcecode distribution and binary distribution.
;If you are not familiar with the GPL, please read LICENSE.TXT.
;(you are welcome to add a "Based On" line above this notice, but this notice must
;remain intact!)
;Released under the GNU General Public License
;
;Contact information: Keith Gable (Ziggy) <ziggy@ignition-project.com>
;Contributors:        Nigel Jones (DigiGuy) <digi_guy@users.sourceforge.net>
;                     Reid Burke  (Airwalk) <airwalk@ignition-project.com>
; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
SetCompressor lzma
!define PRODUCT_NAME "ignitionServices"
!define PRODUCT_VERSION "0.1.1"
!define PRODUCT_VERSION_MAJOR "0"
!define PRODUCT_VERSION_MINOR "1"
!define PRODUCT_VERSION_REVISION "1"
!define PRODUCT_PUBLISHER "The Ignition Project"
!define PRODUCT_WEB_SITE "http://www.ignition-project.com/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\ignitionServices.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "installer.ico"
!define MUI_UNICON "installer.ico"
!define MUI_WELCOMEFINISHPAGE_BITMAP "wizard.bmp"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "header.bmp"
!define MUI_HEADERIMAGE_RIGHT

; Welcome page
!insertmacro MUI_PAGE_WELCOME

; License page
!define MUI_LICENSEPAGE_CHECKBOX
!insertmacro MUI_PAGE_LICENSE "..\docs\license.rtf"

; Directory page
!insertmacro MUI_PAGE_DIRECTORY

; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "ignitionServices"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP

; Components Page
;!insertmacro MUI_PAGE_COMPONENTS

; Instfiles page
!insertmacro MUI_PAGE_INSTFILES

; Finish page
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\docs\readme.txt"
!define MUI_FINISHPAGE_NOREBOOTSUPPORT
!define MUI_FINISHPAGE_LINK "The Ignition Project Homepage"
!define MUI_FINISHPAGE_LINK_LOCATION "${PRODUCT_WEB_SITE}"
!define MUI_FINISHPAGE_TEXT "${PRODUCT_NAME} ${PRODUCT_VERSION} has been installed on your computer. Before running ${PRODUCT_NAME}, please read the readme.\r\n\r\nClick Finish to close this wizard."
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "Setup.exe"
InstallDir "$PROGRAMFILES\ignitionServices"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show
BrandingText "${PRODUCT_NAME} ${PRODUCT_VERSION} Installer" ; how about something a little less weird sounding? :P

Section -Core
  SetOutPath "$INSTDIR"
  SetOverwrite on
  File "..\ignitionServices.exe"
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\ignitionServices.lnk" "$INSTDIR\ignitionServices.exe"
  File "..\changelog.txt"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Changes.lnk" "$INSTDIR\changelog.txt"
  SetOverwrite ifnewer
  SetOutPath "$INSTDIR\docs"
  File "..\docs\credits.txt"
  File "..\docs\license.html"
  File "..\docs\license.rtf"
  File "..\docs\license.txt"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\GNU General Public License.lnk" "$INSTDIR\docs\license.txt"
  File "..\docs\readme.rtf"
  File "..\docs\readme.txt"
  File "..\services.conf"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Read Me First!.lnk" "$INSTDIR\docs\readme.txt"
  File "..\docs\releasenotes.txt"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Release Notes.lnk" "$INSTDIR\docs\releasenotes.txt"
  ;CreateDirectory "$INSTDIR\ChanServ"
  ;CreateDirectory "$INSTDIR\NickServ"
SectionEnd

Section -Utilities
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "..\nickedit.exe"
  File "..\chanedit.exe"
  ; extensions
  WriteRegStr HKCR ".isc" "" "ignition-iscfile"
  WriteRegStr HKCR ".isl" "" "ignition-islfile"
  WriteRegStr HKCR ".isn" "" "ignition-isnfile"
  ; .isc
  WriteRegStr HKCR "ignition-iscfile" "" ""
  WriteRegStr HKCR "ignition-iscfile\DefaultIcon" "" "$INSTDIR\chanedit.exe,0"
  WriteRegStr HKCR "ignition-iscfile\shell" "" ""
  WriteRegStr HKCR "ignition-iscfile\shell\edit" "" ""
  WriteRegStr HKCR "ignition-iscfile\shell\edit\command" "" "$\"$INSTDIR\chanedit.exe$\" %1"
  WriteRegStr HKCR "ignition-iscfile\shell\open" "" ""
  WriteRegStr HKCR "ignition-iscfile\shell\open\command" "" "$\"$INSTDIR\chanedit.exe$\" %1"
  ; .isl
  WriteRegStr HKCR "ignition-islfile" "" ""
  WriteRegStr HKCR "ignition-islfile\DefaultIcon" "" "$INSTDIR\nickedit.exe,0"
  WriteRegStr HKCR "ignition-islfile\shell" "" ""
  WriteRegStr HKCR "ignition-islfile\shell\edit" "" ""
  WriteRegStr HKCR "ignition-islfile\shell\edit\command" "" "$\"$INSTDIR\nickedit.exe$\" %1"
  WriteRegStr HKCR "ignition-islfile\shell\open" "" ""
  WriteRegStr HKCR "ignition-islfile\shell\open\command" "" "$\"$INSTDIR\nickedit.exe$\" %1"
  ; .isn
  WriteRegStr HKCR "ignition-isnfile" "" ""
  WriteRegStr HKCR "ignition-isnfile\DefaultIcon" "" "$INSTDIR\nickedit.exe,0"
  WriteRegStr HKCR "ignition-isnfile\shell" "" ""
  WriteRegStr HKCR "ignition-isnfile\shell\edit" "" ""
  WriteRegStr HKCR "ignition-isnfile\shell\edit\command" "" "$\"$INSTDIR\nickedit.exe$\" %1"
  WriteRegStr HKCR "ignition-isnfile\shell\open" "" ""
  WriteRegStr HKCR "ignition-isnfile\shell\open\command" "" "$\"$INSTDIR\nickedit.exe$\" %1"
SectionEnd

Section -DLLs
  SetOutPath "$SYSDIR"
  SetOverwrite ifdiff
  File "..\dependencies\mswinsck.ocx"
  ; RegDLL "$SYSDIR\mswinsck.ocx"
  Exec '"$SYSDIR\regsvr32.exe" /s "$SYSDIR\mswinsck.ocx"'
SectionEnd

Section -AdditionalIcons
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\The Ignition Project.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\Uninstall.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\ignitionServices.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "InstallLocation" "$INSTDIR"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\Uninstall.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\ignitionServices.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}" "$ICONS_GROUP"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLUpdateInfo" "http://www.ignition-project.com/ignition/services/"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "HelpLink" "http://www.ignition-project.com/forum/"
  WriteRegDWORD ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "VersionMajor" "${PRODUCT_VERSION_MAJOR}"
  WriteRegDWORD ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "VersionMinor" "${PRODUCT_VERSION_MINOR}"
  WriteRegDWORD ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "VersionRevision" "${PRODUCT_VERSION_REVISION}" ; in case of future Windows updates :P
  WriteRegDWORD ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "NoModify" "1"
  WriteRegDWORD ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "NoRepair" "1"
SectionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  ReadRegStr $ICONS_GROUP ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}"
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\Uninstall.exe"
  Delete "$INSTDIR\chanedit.exe"
  delete "$INSTDIR\nickedit.exe"
  Delete "$INSTDIR\ChanServ\*.*"
  Delete "$INSTDIR\NickServ\*.*"
  Delete "$INSTDIR\docs\releasenotes.txt"
  Delete "$INSTDIR\docs\readme.txt"
  Delete "$INSTDIR\docs\readme.rtf"
  Delete "$INSTDIR\docs\license.txt"
  Delete "$INSTDIR\docs\license.rtf"
  Delete "$INSTDIR\docs\license.html"
  Delete "$INSTDIR\docs\credits.txt"
  Delete "$INSTDIR\docs\services.conf" ; don't ask how this keeps happening
  Delete "$INSTDIR\docs\*.*" ; just in case
  Delete "$INSTDIR\services.conf"
  Delete "$INSTDIR\changelog.txt"
  Delete "$INSTDIR\ignitionServices.exe"
  Delete "$INSTDIR\debug.txt" ; delete any debug logs
  
  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\The Ignition Project.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\ignitionServices.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Release Notes.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Read Me First!.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\GNU General Public License.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Changes.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR\docs"
  RMDir "$INSTDIR\ChanServ"
  RMDir "$INSTDIR\NickServ"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  DeleteRegKey HKCR ".isc"
  DeleteRegKey HKCR ".isl"
  DeleteRegKey HKCR ".isn"
  DeleteRegKey HKCR "ignition-iscfile"
  DeleteRegKey HKCR "ignition-islfile"
  DeleteRegKey HKCR "ignition-isnfile"
  SetAutoClose true
SectionEnd
